﻿using System;
using Styx.WoWInternals;

namespace IronBreaker.Core
{
    public class SpellBlacklist
    {
        #region Declarations

        public int SpellId { get; set; }
        public DateTime BlacklistedTime { get; set; }
        public int Count { get; set; }

        #endregion

        #region [Constructor] - SpellBlacklist

        public SpellBlacklist()
        {
            SpellId = 0;
            BlacklistedTime = DateTime.MinValue;
        }

        public SpellBlacklist(int spellId)
        {
            SpellId = spellId;
            Count = 1;
        }

        #endregion

        #region [Method] - Blacklist Helpers

        public bool IsBlackListed()
        {
            TimeSpan ts = new TimeSpan(DateTime.Now.Ticks - BlacklistedTime.Ticks);

            if (BlacklistedTime == DateTime.MinValue)
                return false;
            if (ts.TotalSeconds < 5 && Count >= 3)
                return true;
            else if (Count >= 3 && ts.TotalSeconds >= 5)
                ClearBlacklist();
            return false;
        }

        public void AddBlacklistCounter()
        {
            Count++;

            if (Count >= 3)
            {
                BlacklistedTime = DateTime.Now;
                Utilities.Log.DebugWrite("Spell Blacklisted: " + WoWSpell.FromId(SpellId)?.Name);
            }
        }

        public void ClearBlacklist()
        {
            Count = 0;
            BlacklistedTime = DateTime.MinValue;
        }

        #endregion
    }
}
