﻿using System;
using System.Diagnostics;
using System.Numerics;
using System.Threading.Tasks;
using Buddy.Coroutines;
using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace IronBreaker.Core.Helpers
{
    internal static class Movement
    {
        #region Declarations
        private static LocalPlayer Me => StyxWoW.Me;
        public static string CurrentBot => BotManager.Current.Name.ToUpper();
        private static WoWGuid _lastUnitGuid = WoWGuid.Empty;
        private static readonly Stopwatch LastTimeFace = new Stopwatch();
        public delegate Vector3 LocationDelegate(object ctx);
        public delegate float RangeRetriever(object ctx);
        #endregion

        public static bool CanNavigateToMelee(WoWUnit obj)
        {
            PathInformation inf = Navigator.LookupPathInfo(obj, obj.MeleeRange);
            return inf.Navigability == PathNavigability.Navigable;
        }

        public static async Task<bool> MoveToTarget(WoWUnit target)
        {
            if (target == null || Me.IsWithinMeleeRangeOf(target) || !target.IsValidCombatUnit() || Me.IsCasting ||
                Me.IsChanneling || !Main.IS.AutoMove)
                return false;

            if (Me.IsWithinMeleeRangeOf(target))
                return await CommonCoroutines.StopMoving();
            if (!Me.IsWithinMeleeRangeOf(target))
                await CommonCoroutines.MoveTo(target.RelativeLocation, target.SafeName);
            return true;
        }

        public static async Task StopMoving(Func<bool> conditionCheck = null)
        {
            if (conditionCheck != null && !conditionCheck())
                return;

            await CommonCoroutines.StopMoving();
        }

        public static async Task<bool> FaceCurrentTarget(WoWUnit target)
        {
            if (target == null || Me.IsSafelyFacing(target) || !target.IsValidCombatUnit() || !Main.IS.AutoFace)
                return false;
            target.Face();
            _lastUnitGuid = target.Guid;

            if (Me.IsWithinMeleeRangeOf(target) && Me.IsMoving && Main.IS.AutoMove)
                return await CommonCoroutines.StopMoving();
            if (!LastTimeFace.IsRunning)
                LastTimeFace.Start();
            else
                LastTimeFace.Restart();
            await Coroutine.Yield();
            return true;
        }

        public static async Task FaceTarget(WoWUnit target, Func<bool> conditionCheck = null)
        {
            if (conditionCheck != null && !conditionCheck())
                return;

            target.Face();
            await CommonCoroutines.SleepForLagDuration();
            await Coroutine.Yield();
        }

        public static async Task<bool> ClearTheDead()
        {
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsDead)
            {
                Me.ClearTarget();
                await CommonCoroutines.SleepForLagDuration();
                return false;
            }
            return false;
        }
    }
}
