﻿using System.Windows.Forms;
using Styx;
using Styx.Common;
using M = IronBreaker.Main;

namespace IronBreaker.Core.Managers
{
    internal class HotkeyManagement
    {
        #region Declarations
        public static bool KeysRegistered { get; set; }
        public static bool FacingOn { get; set; }
        public static bool TargetingOn { get; set; }
        public static bool MovementOn { get; set; }
        public static bool AutoPullOn { get; set; }
        public static bool AutoAoEOn { get; set; }
        public static bool BurstOn { get; set; }
        #endregion

        public static void RegisterHotkeys()
        {
            if (KeysRegistered)
                return;

            #region Initialize Hotkeys
            FacingOn = M.IS.AutoFace;
            MovementOn = M.IS.AutoMove;
            TargetingOn = M.IS.AutoTarget;
            AutoPullOn = M.IS.AutoPull;
            AutoAoEOn = M.IS.AutoAoE;
            #endregion

            if (M.IS.AutomationKey != 0)
            {
                if (M.IS.FacingKey != 0)
                {
                    HotkeysManager.Register("FacingOn", (Keys)M.IS.FacingKey,
                        (ModifierKeys)M.IS.AutomationKey,
                        ret =>
                        {
                            FacingOn = !FacingOn;
                            M.IS.AutoFace = FacingOn;
                            StyxWoW.Overlay.AddToast(FacingOn ? "Facing Mode: Enabled" : "Facing Mode: Disabled!", 2000);
                        });
                }

                if (M.IS.TargetingKey != 0)
                {
                    HotkeysManager.Register("TargetOn", (Keys)M.IS.TargetingKey,
                        (ModifierKeys)M.IS.AutomationKey,
                        ret =>
                        {
                            TargetingOn = !TargetingOn;
                            M.IS.AutoTarget = TargetingOn;
                            StyxWoW.Overlay.AddToast(TargetingOn ? "Target Mode: Enabled" : "Target Mode: Disabled",
                                2000);
                        });
                }
                if (M.IS.MovementKey != 0)
                {
                    HotkeysManager.Register("MovementOn", (Keys)M.IS.MovementKey,
                        (ModifierKeys)M.IS.AutomationKey,
                        ret =>
                        {
                            MovementOn = !MovementOn;
                            M.IS.AutoMove = MovementOn;
                            StyxWoW.Overlay.AddToast(MovementOn ? "Movement Mode: Enabled" : "Movement Mode: Disabled",
                                2000);
                        });
                }

                if (M.IS.PullKey != 0)
                {
                    HotkeysManager.Register("PullOn", (Keys)M.IS.PullKey, (ModifierKeys)M.IS.AutomationKey,
                        ret =>
                        {
                            AutoPullOn = !AutoPullOn;
                            M.IS.AutoPull = AutoPullOn;
                            StyxWoW.Overlay.AddToast(AutoPullOn ? "Auto Pull: Enabled" : "Auto Pull: Disabled", 2000);
                        });
                }

                if (M.IS.AoEKey != 0)
                {
                    HotkeysManager.Register("AoEOn", (Keys)M.IS.AoEKey, (ModifierKeys)M.IS.AutomationKey,
                        ret =>
                        {
                            AutoAoEOn = !AutoAoEOn;
                            M.IS.AutoAoE = AutoAoEOn;
                            StyxWoW.Overlay.AddToast(AutoAoEOn ? "Auto AOE: Enabled" : "Auto AOE: Disabled", 2000);
                        });
                }

                if (M.IS.BurstKey != 0)
                {
                    HotkeysManager.Register("BurstOn", (Keys)M.IS.BurstKey, (ModifierKeys)M.IS.AutomationKey,
                        ret =>
                        {
                            BurstOn = !BurstOn;
                            StyxWoW.Overlay.AddToast(BurstOn ? "Burst Mode: Enabled" : "Burst Mode: Disabled", 2000);
                        });
                }
                
            }
            KeysRegistered = true;
        }

        public static void RemoveHotkeys()
        {
            if (!KeysRegistered)
                return;

            HotkeysManager.Unregister("FacingOn");
            HotkeysManager.Unregister("TargetOn");
            HotkeysManager.Unregister("MovementOn");
            HotkeysManager.Unregister("PullOn");
            HotkeysManager.Unregister("AoEOn");
            HotkeysManager.Unregister("BurstOn");

            FacingOn = false;
            TargetingOn = false;
            MovementOn = false;
            AutoPullOn = false;
            AutoAoEOn = false;
            BurstOn = false;
            KeysRegistered = false;
        }
    }
}
