﻿using System;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using IronBreaker.Core.Utilities;

namespace IronBreaker.Core.Managers
{
    internal class TalentManagement
    {
        private static LocalPlayer Me => StyxWoW.Me;
        public static event EventHandler specChanged;
        public static WoWSpec CurrentSpec { get; private set; }

        static TalentManagement()
        {
            
        }

        private static void OnSpecChanged(EventArgs args)
        {
            EventHandler handler = specChanged;
            handler?.Invoke(null, args);
        }

        #region [Method] - Initialize

        public static void InitializeTalents()
        {
            SetTalentEvents();
            SetTalents();
        }

        private static void InitializeTalents(object sender, LuaEventArgs args)
        {
            Log.InfoLog("[Event] Talent Initialization: " + args.EventName, Coloring.Info);
            SetTalents();
        }

        public static void UpdateTalents()
        {
            InitializeTalents();
            //PrintTalents();
        }

        #endregion

        #region Talents

        public static bool
            Dauntless,
            Overpower,
            SweepingStrikes,
            WarMachine,
            EndlessRage,
            FreshMeat,
            Warbringer,
            Shockwave,
            StormBolt,
            DoubleTime,
            ImpendingVictory,
            InspiringPresence,
            Safeguard,
            FervorOfBattle,
            Rend,
            Avatar,
            WreckingBall,
            Outburst,
            RenewedFury,
            Ultimatum,
            SecondWind,
            BoundingStrikes,
            DefensiveStance,
            FuriousCharge,
            Warpaint,
            WarlordsChallenge,
            CracklingThunder,
            InForTheKill,
            MortalCombo,
            FocusedRage,
            Massacre,
            FrothingBerserker,
            Carnage,
            BestServedCold,
            NeverSurrender,
            Indomitable,
            DeadlyCalm,
            Trauma,
            TitanicMight,
            Bloodbath,
            Frenzy,
            InnerRage,
            Vengeance,
            IntoTheFray,
            BoomingVoice,
            AngerManagement,
            OpportunityStrikes,
            Ravager,
            Bladestorm,
            RecklessAbandon,
            DragonRoar,
            HeavyRepercussions;

        #endregion

        #region [Method] - Get Talents

        private static bool GetTalent(int tier, int idx)
        {
            tier--;
            idx--;
            return Me.GetLearnedTalent(tier)?.Index == idx;
        }

        #endregion

        #region [Method] - Set Talents

        private static void SetTalents()
        {
            if (Me.Level < 15)
                return;

            if (Me.Specialization == WoWSpec.WarriorArms)
            {
                if (Me.Level >= 15)
                {
                    Dauntless = GetTalent(1, 1);
                    Overpower = GetTalent(1, 2);
                    SweepingStrikes = GetTalent(1, 3);
                }

                if (Me.Level >= 30)
                {
                    Shockwave = GetTalent(2, 1);
                    StormBolt = GetTalent(2, 2);
                    DoubleTime = GetTalent(2, 3);
                }

                if (Me.Level >= 45)
                {
                    FervorOfBattle = GetTalent(3, 1);
                    Rend = GetTalent(3, 2);
                    Avatar = GetTalent(3, 3);
                }

                if (Me.Level >= 60)
                {
                    SecondWind = GetTalent(4, 1);
                    BoundingStrikes = GetTalent(4, 2);
                    DefensiveStance = GetTalent(4, 3);
                }

                if (Me.Level >= 75)
                {
                    InForTheKill = GetTalent(5, 1);
                    MortalCombo = GetTalent(5, 2);
                    FocusedRage = GetTalent(5, 3);
                }

                if (Me.Level >= 90)
                {
                    DeadlyCalm = GetTalent(6, 1);
                    Trauma = GetTalent(6, 2);
                    TitanicMight = GetTalent(6, 3);
                }

                if (Me.Level >= 100)
                {
                    AngerManagement = GetTalent(7, 1);
                    OpportunityStrikes = GetTalent(7, 2);
                    Ravager = GetTalent(7, 3);
                }
            }

            if (Me.Specialization == WoWSpec.WarriorFury)
            {
                if (Me.Level >= 15)
                {
                    WarMachine = GetTalent(1, 1);
                    EndlessRage = GetTalent(1, 2);
                    FreshMeat = GetTalent(1, 3);
                }

                if (Me.Level >= 30)
                {
                    Shockwave = GetTalent(2, 1);
                    StormBolt = GetTalent(2, 2);
                    DoubleTime = GetTalent(2, 3);
                }

                if (Me.Level >= 45)
                {
                    WreckingBall = GetTalent(3, 1);
                    Outburst = GetTalent(3, 2);
                    Avatar = GetTalent(3, 3);
                }

                if (Me.Level >= 60)
                {
                    FuriousCharge = GetTalent(4, 1);
                    BoundingStrikes = GetTalent(4, 2);
                    Warpaint = GetTalent(4, 3);
                }

                if (Me.Level >= 75)
                {
                    Massacre = GetTalent(5, 1);
                    FrothingBerserker = GetTalent(5, 2);
                    Carnage = GetTalent(5, 3);
                }

                if (Me.Level >= 90)
                {
                    Bloodbath = GetTalent(6, 1);
                    Frenzy = GetTalent(6, 2);
                    InnerRage = GetTalent(6, 3);
                }

                if (Me.Level >= 100)
                {
                    Bladestorm = GetTalent(7, 1);
                    RecklessAbandon = GetTalent(7, 2);
                    DragonRoar = GetTalent(7, 3);
                }
            }

            if (Me.Specialization == WoWSpec.WarriorProtection)
            {
                if (Me.Level >= 15)
                {
                    Shockwave = GetTalent(1, 1);
                    StormBolt = GetTalent(1, 2);
                    Warbringer = GetTalent(1, 3);
                }

                if (Me.Level >= 30)
                {
                    ImpendingVictory = GetTalent(2, 1);
                    InspiringPresence = GetTalent(2, 2);
                    Safeguard = GetTalent(2, 3);
                }

                if (Me.Level >= 45)
                {
                    RenewedFury = GetTalent(3, 1);
                    Ultimatum = GetTalent(3, 2);
                    Avatar = GetTalent(3, 3);
                }

                if (Me.Level >= 60)
                {
                    WarlordsChallenge = GetTalent(4, 1);
                    BoundingStrikes = GetTalent(4, 2);
                    CracklingThunder = GetTalent(4, 3);
                }

                if (Me.Level >= 75)
                {
                    BestServedCold = GetTalent(5, 1);
                    NeverSurrender = GetTalent(5, 2);
                    Indomitable = GetTalent(5, 3);
                }

                if (Me.Level >= 90)
                {
                    Vengeance = GetTalent(6, 1);
                    IntoTheFray = GetTalent(6, 2);
                    BoomingVoice = GetTalent(6, 3);
                }

                if (Me.Level >= 100)
                {
                    AngerManagement = GetTalent(7, 1);
                    HeavyRepercussions = GetTalent(7, 2);
                    Ravager = GetTalent(7, 3);
                }
            }
        }

        public static void SetTalentEvents()
        {
            using (StyxWoW.Memory.AcquireFrame())
            {
                Lua.Events.AttachEvent("PLAYER_LEVEL_UP", OnLevelUp);
                //Lua.Events.AttachEvent("CHARACTER_POINTS_CHANGED", InitializeTalents);
                Lua.Events.AttachEvent("ACTIVE_TALENT_GROUP_CHANGED", ActiveTalentGroupChanged);
                //Lua.Events.AttachEvent("PLAYER_SPECIALIZATION_CHANGED", TalentSpecChanged);
                //Lua.Events.AttachEvent("LEARNED_SPELL_IN_TAB", InitializeTalents);
                //Lua.Events.AttachEvent("PLAYER_TALENT_UPDATE", PlayerTalentUpdate);
            }
        }

        public static void RemoveTalentEvents()
        {
            Lua.Events.DetachEvent("PLAYER_LEVEL_UP", OnLevelUp);
            Lua.Events.DetachEvent("ACTIVE_TALENT_GROUP_CHANGED", ActiveTalentGroupChanged);
        }

        private static void LearnedSpellInTab(object sender, LuaEventArgs args)
        {
            Log.InfoLog("[Event] Learned Spell in Tab: " + args.EventName, Coloring.Info);
            InitializeTalents(sender, args);
        }

        #endregion

        #region [Method] - Update Talents

        private static void OnLevelUp(object sender, LuaEventArgs args)
        {
            Log.InfoLog(string.Format($"We Leveled up! Leveling {args.Args[0]}"), Coloring.Info);
            SetTalents();
        }

        private static void PlayerTalentUpdate(object sender, LuaEventArgs args)
        {
            Log.InfoLog("[Event] Player Talents Updated: " + args.EventName, Coloring.Info);
            InitializeTalents(sender, args);
        }

        private static void UpdateTalentManager(object sender, LuaEventArgs args)
        {
            Log.InfoLog("***************************", Coloring.Info);
            Log.InfoLog("**** Talent(s) Changed ****", Coloring.Info);
            Log.InfoLog("***************************", Coloring.Info);
            InitializeTalents();
            //PrintTalents();
        }

        private static void CharacterPointsChanged(object sender, LuaEventArgs args)
        {
            Log.InfoLog("[Event] Player Points Changed: " + args.EventName, Coloring.Info);
            InitializeTalents(sender, args);
        }

        private static void ActiveTalentGroupChanged(object sender, LuaEventArgs args)
        {
            Log.InfoLog("[Event] Active Talent Group Changed: " + args.EventName, Coloring.Info);
            InitializeTalents(sender, args);
        }

        #endregion
    }
}
