﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Bots.DungeonBuddy.Helpers;
using Buddy.Coroutines;
using IronBreaker.Core.Helpers;
using IronBreaker.Core.Utilities;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Color = System.Drawing.Color;
using M = IronBreaker.Main;

namespace IronBreaker.Core
{
    internal static class Spell
    {
        #region [Method] - Declarations
        public static int LastSpell;
        public static string LastSpellName;
        private static LocalPlayer Me => StyxWoW.Me;
        private static WoWUnit CurrentTarget => StyxWoW.Me.CurrentTarget;
        private static readonly List<SpellBlacklist> GroundSpellBlacklist = new List<SpellBlacklist>();
        private static Dictionary<string, long> UndefinedSpells { get; set; }
        private static string BuffName { get; set; }
        private static string SpellName { get; set; }
        private static string GcdSpellName { get; set; }
        #endregion

        #region [Method] - Cooldown Detection

        public static double CooldownTimeLeft(int spell)
        {
            try
            {
                SpellFindResults results;

                return SpellManager.FindSpell(spell, out results)
                    ? (results.Override?.CooldownTimeLeft.TotalMilliseconds ?? results.Original.CooldownTimeLeft.TotalMilliseconds)
                    : 9999;
            }
            catch (Exception ex)
            {
                Log.DiagnosticLog("Exception in CooldownTimeLeft() Method;", ex);
                return 0000;
            }
        }

        public static bool OnCooldown(int spell)
        {
            try
            {
                SpellFindResults results;
                SpellManager.FindSpell(spell, out results);
                return results.Override?.Cooldown ?? results.Original.Cooldown;
            }
            catch (Exception ex)
            {
                Log.DiagnosticLog("Exception in OnCooldown(int spell); Method.", ex);
                return false;
            }
        }

        public static bool IsOnCooldown(WoWSpell spell)
        {
            if (spell == null) { return true; }
            if (Me.ChanneledCastingSpellId != 0) { return true; }
            uint numb = M.Latency * 2u;
            if (StyxWoW.Me.IsCasting && Me.CurrentCastTimeLeft.TotalMilliseconds > numb) { return true; }
            if (spell.CooldownTimeLeft.TotalMilliseconds > numb) { return true; }
            return false;
        }

        public static bool IsOnCooldown(int spellId)
        {
            WoWSpell spell = WoWSpell.FromId(spellId);
            return IsOnCooldown(spell);
        }

        public static bool IsOnCooldown(string castName)
        {
            SpellFindResults results;
            if (!SpellManager.FindSpell(castName, out results)) { return true; }
            WoWSpell spell = results.Override ?? results.Original;
            return IsOnCooldown(spell);
        }

        #endregion

        #region [Method] - Buffing

        #region [Method] - By ID

        public static async Task<bool> Buff(int spell, Color color, bool reqs = true, string log = "")
        {
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(spell), Me, false, false, false))
                return false;
            if (!SpellManager.Cast(spell, Me))
                return false;

            LastSpell = spell;
            if (M.IS.EnableCombatLog)
                Log.InfoLog(log, color);

            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        #endregion

        #region [Method] - By Name

        public static async Task<bool> Buff(string buffName, Color color, bool reqs = true, string log = "")
        {
            BuffName = buffName;
            if (BuffName == null)
                return false;

            if (!reqs)
                return false;
            SpellFindResults results;
            if (!SpellManager.FindSpell(BuffName, out results))
                return false;

            if (results.Override != null)
                BuffName = results.Override.Name;

            if (!SpellManager.Cast(BuffName, Me))
                return false;

            LastSpellName = buffName;

            if (M.IS.EnableCombatLog)
                Log.InfoLog(log, color);

            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        #endregion

        #endregion

        #region [Method] - Casting

        #region [Method] By ID

        public static async Task<bool> Cast(int spell, Color color, bool reqs = true, string log = "", bool sleep = true)
        {
            if (!CurrentTarget.IsValidCombatUnit())
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(spell), CurrentTarget, false, false, false))
                return false;
            if (!SpellManager.Cast(spell, CurrentTarget))
                return false;

            LastSpell = spell;

            if (M.IS.EnableCombatLog)
                Log.CombatLog(log, color);

            if (sleep)
                await CommonCoroutines.SleepForLagDuration();
            else
                await Coroutine.Yield();

            return true;
        }

        #endregion

        #region [Method] By Name

        public static async Task<bool> Cast(string spellName, Color color, bool reqs = true, string log = "", bool sleep = true)
        {
            SpellName = spellName;
            if (SpellName == null)
                return false;
            if (!CurrentTarget.IsValidCombatUnit())
                return false;
            if (!reqs)
                return false;

            SpellFindResults results;

            if (!SpellManager.FindSpell(SpellName, out results))
                return false;

            if (results.Override != null)
                SpellName = results.Override.Name;

            if (!SpellManager.Cast(SpellName, Me))
                return false;

            LastSpellName = SpellName;

            if (M.IS.EnableCombatLog)
                Log.CombatLog(log, color);

            if (sleep)
                await CommonCoroutines.SleepForLagDuration();
            else
                await Coroutine.Yield();

            return true;
        }

        #endregion

        #endregion

        #region [Method] - Global Cooldown

        #region By ID

        public static async Task<bool> Gcd(int spell, Color color, bool reqs = true, string log = "", bool sleep = true)
        {
            if (!reqs)
                return false;
            if (OnCooldown(spell))
                return false;
            if (!SpellManager.Cast(spell))
                return false;

            LastSpell = spell;

            if (M.IS.EnableCombatLog)
                Log.CombatLog(log, color);

            if (sleep)
                await CommonCoroutines.SleepForLagDuration();
            else
                await Coroutine.Yield();

            return true;
        }

        public static async Task<bool> GcdTarget(int spell, WoWUnit target, Color color, bool reqs = true, string log = "")
        {
            if (!reqs)
                return false;
            if (OnCooldown(spell))
                return false;
            if (!SpellManager.Cast(spell))
                return false;

            LastSpell = spell;

            if (M.IS.EnableCombatLog)
                Log.CombatLog(log, color);

            await CommonCoroutines.SleepForRandomReactionTime();
            return true;
        }

        #endregion

        #region By Name

        public static async Task<bool> Gcd(string spellName, Color color, bool reqs = true, string log = "", bool sleep = true)
        {
            GcdSpellName = spellName;
            if (GcdSpellName == null)
                return false;

            if (!reqs)
                return false;

            SpellFindResults results;
            if (!SpellManager.FindSpell(GcdSpellName, out results))
                return false;

            if (results.Override != null)
                GcdSpellName = results.Override.Name;

            if (!SpellManager.Cast(GcdSpellName, Me))
                return false;

            LastSpellName = GcdSpellName;

            if (M.IS.EnableCombatLog)
                Log.CombatLog(log, color);

            if (sleep)
                await CommonCoroutines.SleepForLagDuration();
            else
                await Coroutine.Yield();
            return true;
        }

        #endregion

        #endregion

        #region [Method] - Ground Casting

        #region [Method] - CastGround Overloads

        public static async Task<bool> CastGround(int spell, WoWUnit target, Color color, bool reqs = true, string addLog = "")
        {
            if (GroundSpellBlacklist.Any(s => s.SpellId == spell && s.IsBlackListed()))
                return false;

            if (!reqs) { return false; }
            if (!target.IsValidCombatUnit())
                return false;

            if (!SpellManager.CanCast(WoWSpell.FromId(spell), target, false, false, false))
                return false;

            if (await Gcd(spell, color, true, addLog) && !await Coroutine.Wait(1000, () => Me.CurrentPendingCursorSpell != null))
            {
                AddSpellToBlacklist(spell);
                Log.DiagnosticLog("No Cursor Detected!!");
                return false;
            }

            LastSpell = spell;
            if (SpellManager.ClickRemoteLocation(target.Location) == false) { AddSpellToBlacklist(spell); }
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static async Task<bool> CastGround(int spell, Color color, bool reqs = true, string log = "")
        {
            if (!reqs)
                return false;

            return await CastGround(spell, CurrentTarget, color, reqs, log);
        }

        #endregion

        #region [Method] - Cast Ground on Me

        public static async Task<bool> CastGroundOnMe(int spell, Color color, bool reqs = true, string log = "")
        {
            if (GroundSpellBlacklist.Any(s => s.SpellId == spell && s.IsBlackListed()))
                return false;
            if (!reqs)
                return false;

            if (!SpellManager.CanCast(WoWSpell.FromId(spell)))
                return false;

            if (await Gcd(spell, color, true, log) &&
                !await Coroutine.Wait(1000, () => Me.CurrentPendingCursorSpell != null))
            {
                AddSpellToBlacklist(spell);
                Log.DiagnosticLog("No Cursor Detected!!");
                return false;
            }

            LastSpell = spell;
            if (SpellManager.ClickRemoteLocation(Me.Location) == false)
                AddSpellToBlacklist(spell);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        #endregion

        #region [Method] - Add to SpellBlacklist

        private static void AddSpellToBlacklist(int spellId)
        {
            var spell = GroundSpellBlacklist.FirstOrDefault(bl => bl.SpellId == spellId);
            if (spell != null)
            {
                spell.AddBlacklistCounter();
            }
            else
            {
                GroundSpellBlacklist.Add(new SpellBlacklist(spellId));
            }
        }

        #endregion

        #endregion

        #region [Method] - Cast Checks

        public static bool CanCast(SpellFindResults results, WoWUnit unit, bool check = false)
        {
            WoWSpell spell = results.Override ?? results.Original;

            if (!CanCastInRange(spell, unit))
                return false;
            if (CanCastWhileMoving(spell, unit))
                return false;
            if (!check && !spell.CanCast && (results.Override == null || !results.Original.CanCast))
            {
                if (M.IS.EnableDebugLog)
                    Log.DebugWrite("CanCast[{0}] -> Spell CanCast() Failed!", spell.Name);
                return false;
            }
            return true;
        }

        public static bool CanCast(string spell, WoWUnit unit, bool check = false)
        {
            SpellFindResults results;
            if (!SpellManager.FindSpell(spell, out results))
            {
                AddToUndefinedSpells(spell);
                return false;
            }
            return CanCast(results, unit, check);
        }

        public static bool CanCast(string spell)
        {
            return CanCast(spell, Me.CurrentTarget, check: false);
        }

        #endregion

        #region [Method] - Get Spell Charges

        public static bool IsMaxChargesAvailable(int spell)
        {
            SpellChargeInfo charges = GetSpellChargeInfo(spell);
            return charges != null && charges.ChargesLeft == charges.MaxCharges;
        }

        public static int GetCharges(int spell)
        {
            SpellFindResults results;
            SpellManager.FindSpell(spell, out results);
            int charges = Lua.GetReturnVal<int>("return GetSpellCharges(" + spell + ")", 0);
            return charges;
        }

        public static SpellChargeInfo GetSpellChargeInfo(int spell)
        {
            try
            {
                SpellFindResults results;
                SpellManager.FindSpell(spell, out results);
                return results.Override != null ? results.Override.GetChargeInfo() : results.Original.GetChargeInfo();
            }
            catch (Exception ex)
            {
                Log.DiagnosticLog("Exception in GetSpellChargeInfo() Method in the 'Spell' Class.", ex);
                return null;
            }
        }

        #endregion

        #region [Method] - Helpers

        public static float SpellDistance(this WoWUnit origin, WoWUnit unitTarget = null)
        {
            if (origin == null) { return 0; }
            if (unitTarget == null) { unitTarget = StyxWoW.Me; }
            if (unitTarget.IsMe) { unitTarget = origin; origin = StyxWoW.Me; }
            float dist = unitTarget.Location.Distance(origin.Location) - unitTarget.CombatReach;
            return Math.Max(0, dist);
        }

        private static void AddToUndefinedSpells(string s)
        {
            if (UndefinedSpells.ContainsKey(s))
                UndefinedSpells[s] = UndefinedSpells[s] + 1;
            else
                UndefinedSpells.Add(s, 1);
        }

        public static bool CanCastInRange(WoWSpell spell, WoWUnit unit)
        {
            if (unit != null && !spell.IsSelfOnlySpell && !unit.IsMe)
            {
                if (spell.IsMeleeSpell && !unit.IsWithinMeleeRange)
                {
                    if (M.IS.EnableDebugLog)
                        Log.DebugWrite("CanCast[{0}] -> Target not in melee Range!", spell.Name);
                    return false;
                }

                if (spell.HasRange)
                {
                    if (unit.Distance > spell.ActualMaxRange(unit))
                    {
                        if (M.IS.EnableDebugLog)
                            Log.DebugWrite(string.Format($"CanCast -> Out of Range for Spell: {spell.Name}"));
                        return false;
                    }

                    if (unit.Distance < spell.ActualMinRange(unit))
                    {
                        if (M.IS.EnableDebugLog)
                            Log.DebugWrite(string.Format($"CanCast -> Out of range for spell: {spell.Name}"));
                        return false;
                    }
                }

                if (!unit.InLineOfSpellSight)
                {
                    if (M.IS.EnableDebugLog)
                        Log.DebugWrite(string.Format($"CanCast -> Target is not in Spell {spell.Name} LOS"));
                    return false;
                }
            }
            return true;
        }

        public static bool CanCastWhileMoving(WoWSpell spell, WoWUnit unit)
        {
            if ((spell.CastTime != 0u || spell.IsChanneled) && Me.IsMoving)
            {
                if (M.IS.EnableDebugLog)
                    Log.DebugWrite(string.Format($"Can't cast {spell.Name} while moving!"));
                return true;
            }
            return false;
        }

        #endregion
    }
}
