﻿using System;

namespace IronBreaker.Core.Utilities
{
    #region ComboBox Conditions

    public enum WarbreakerType
    {
        Never,
        OnCooldown,
        OnBurst,
        MaintainDebuff,
        PlayerBossElite,
        TargetHp,
        TargetCount,
    }

    public enum ImpendingVictoryType
    {
        HpBelow,
        PlayerBossElite,
        OnCooldown
    }

    public enum ArmsType
    {
        OnBurst,
        OnCooldown,
        TargetCount,
    }

    public enum CrowdControlType
    {
        HpBelow,
        TargetCount,
        TargetCastAny,
        TargetCastHeal,
    }

    public enum BurstType
    {
        Never,
        PlayerBossElite,
        BurstKeys,
        HpBelow,
        OnCooldown,
        TargetCount,
        TargetHpBelow
    }

    public enum ClassType
    {
        PlayerBossElite,
        OnBurst,
        OnCooldown,
    }

    public enum BuffType
    {
        HpBelow,
        PlayerBossElite,
        OnCooldown,
        TargetCount,
    }

    public enum DefenseType
    {
        HpBelow,
        OnCooldown,
        TargetCount,
    }

    public enum SingleStunType
    {
        OnCooldown,
        HpBelow,
        TargetCastAny,
        TargetCastHeal,
    }

    public enum AoEStunType
    {
        OnCooldown,
        OnBurst,
        HpBelow,
        TargetCount,
        TargetCastAny,
        TargetCastHeal
    }

    public enum InterruptType
    {
        TargetCastAny,
        TargetCastHeal,
    }
    #endregion

    [Flags]
    public enum WoWContext
    {
        None = 0,
        Normal = 0x1,
        Instances = 0x2,
        Battlegrounds = 0x4,
        All = Normal | Instances | Battlegrounds
    }

    [Flags]
    public enum BehaviorType
    {
        Rest = 0x1,
        PreCombatBuffs = 0x2,
        PullBuffs = 0x4,
        Pull = 0x8,
        Heal = 0x10,
        CombatBuffs = 0x20,
        Combat = 0x40,
        LossOfControl = 0x80,
        Death = 0x100,
        Initialize = 0x200,
        InCombat = Heal | CombatBuffs | Combat,
        OutOfCombat = Rest | PreCombatBuffs | PullBuffs | Death,
        All = Rest | PreCombatBuffs | PullBuffs | Pull | Heal | CombatBuffs | Combat | LossOfControl | Death
    }
}
