﻿using System;
using Styx.CommonBot;
using Styx.CommonBot.Routines;

namespace IronBreaker
{
    public enum IronBreakerBotEvent
    {
        BotChanged,
        BotStarted,
        BotStopped
    }

    public class IronBreakerBotEventArg : EventArgs
    {
        public readonly IronBreakerBotEvent Event;

        public IronBreakerBotEventArg(IronBreakerBotEvent ev)
        {
            Event = ev;
        }
    }

    partial class Main
    {
        public static event EventHandler<IronBreakerBotEventArg> OnBotEvent;
        private static bool _botEventSubscribed;

        private void IronBreakerBotEventInitialize()
        {
            if (!_botEventSubscribed)
            {
                _botEventSubscribed = true;
                BotEvents.OnBotChanged += e => DemonizeRaiseEvent(IronBreakerBotEvent.BotChanged);
                BotEvents.OnBotStarted += e => DemonizeRaiseEvent(IronBreakerBotEvent.BotStarted);
                BotEvents.OnBotStopped += e => DemonizeRaiseEvent(IronBreakerBotEvent.BotStopped);
            }
        }

        public void DemonizeRaiseEvent(IronBreakerBotEvent ev)
        {
            try
            {
                if (_botEventSubscribed && RoutineManager.Current.Name == Name)
                    OnBotEvent?.Invoke(this, new IronBreakerBotEventArg(ev));
            }
            catch (Exception)
            {
            }
        }
    }
}
